1.2 Explorando la interfaz

# La interfaz de Sonic Pi

Sonic Pi tiene una interfaz sencilla para programar música. Echemos un vistazo a esto.

![Interfaz de Sonic Pi](../images/tutorial/GUI.png)


*A* - Controles de Ejecución
*B* - Controles de edición
*C* - Información y Ayuda
*D* - Editor de código
*E* - Panel de Preferencias
*F* - Visor de Registros
*G* - Sistema de Ayuda
*H* - Scope Viewer

## A. Controles de Ejecución

Estos botones rosados son los principales controles para comenzar y parar sonidos. El botón de *Ejecutar* sirve para iniciar la ejecución del código y *Parar* para parar todo código en Ejecución, *Guardar* para guardar el código a un archivo externo y *Grabar* para crear una grabación (archivo WAV) de los sonidos ejecutándose.

## B. Controles de edición

Estos botones anaranjados te permiten manipular el editor del código. Los botones *Tamaño+* y *Tamaño-* permiten cambiar el tamaño del texto. El botón *Alinear* hará que tu código este más claro y profesional.

## C. Información y Ayuda

Estos botones azules te dan acceso a información, ayuda y preferencias. El botón *Info* abre la ventana informativa, la cual contiene información del propio programa Sonic Pi - el equipo base, historia, contribuyentes y la comunidad. El botón de *Ayuda* muestra u oculta el sistema de ayuda y el botón *Preferencias* activa la ventana de preferencias, que te permite controlar algunos parámetros básicos del sistema.

## D. Editor de código

Esta es el área donde escribirás tu código y compondrás/ejecutarás música. Es un sencillo editor de texto donde puedes escribir, borrar, cortar, pegar, etc. Piensa que es una versión simplificada de Word o Google Docs. El editor colorea las palabras automáticamente, basado en su significado para el código. Al principio, esto puede parecer extraño, pero pronto lo encontrarás muy útil. Por ejemplo, sabrás que algo es un número, porque es de color azul.

## E. Panel de Preferencias

Sonic Pi supports a number of tweakable preferences which can be accessed by toggling the *prefs* button in the Info and Help button set. This will toggle the visibility of the Prefs Panel which includes a number of options to be changed. Examples are forcing mono mode, inverting stereo, toggling log output verbosity and also a volume slider and audio selector on the Raspberry Pi.

## F. Visor de Log

Cuando ejecutas un código, el visualizador del log muestra información de lo que está haciendo el programa. Predeterminado está el que veas un mensaje por cada sonido que crees con el tiempo exacto al que fue disparado el sonido. Esto es muy útil para depurar código y entender qué es lo que está haciendo.

## G. Sistema de ayuda

One of the most important parts of the Sonic Pi interface is the help system which appears at the bottom of the window. This can be toggled on and off by clicking on the blue *Help* button. The help system contains help and information about all aspects of Sonic Pi including this tutorial, a list of available synths, samples, examples, FX and a full list of all the functions Sonic Pi provides for coding music.

## H. Scope Viewer

The scope viewer allows you to see the sound you're hearing. You can easily see that the saw wave looks like a saw and that the basic beep is a curvey sine wave. You can also see the difference between loud and quiet sounds by the size of the lines. There are 3 scopes to play with - the default is a combined scope for the left and right channels, there is a stereo scope which draws a separate scope for each channel. Finally there is a Lissajous curve scope which will show the phase relationship between the left and right channels and allows you to draw pretty pictures with sound (https://en.wikipedia.org/wiki/Lissajous_curve).
