1.2 Découverte de l'interface

# L'Interface de Sonic Pi

Sonic Pi a une interface très simple pour coder de la musique. Passons un peu de temps à l'explorer.

![Interface de Sonic Pi](../images/tutorial/GUI.png)


*A* - Contrôles de jeu
*B* - Contrôles d'édition
*C* - Info et aide
*D* - Éditeur de code
*E* - Panneau des préférences
*F* - Visualisateur de la trace
*G* - Système d'aide
*H* - Scope Viewer

## A. Contrôles de jeu

Ces boutons roses sont les principaux contrôles pour démarrer et arrêter les sons. Il y a le bouton *Run* pour exécuter le code présent dans l'éditeur, *Stop* pour arrêter tous les codes en cours d'exécution, *Save* pour sauvegarder le code dans un fichier externe et *Record* pour créer un enregistrement du son (un fichier WAV) en cours de jeu.

## B. Contrôles d'édition

Ces boutons oranges vous permettent de piloter l'éditeur de code. Les boutons *Size +* et *Size -* vous permettent d'agrandir ou de rétrécir le texte. Le bouton *Align* vous arrangera votre code pour lui donner une présentation plus professionnelle.

## C. Info et Aide

Ces boutons bleus vous donnent accès à l'information, à l'aide et aux préférences. Le bouton *Info* ouvre la fenêtre d'information qui contient de l'information sur Sonic Pi lui-même - le noyau de l'équipe, l'historique, les contributeurs, et la communauté. Le bouton *Aide* active le système d'aide (*G*) et le bouton *Prefs* active la fenêtre des préférences qui vous permet de contrôler quelques paramètres systèmes basiques.

## D. Éditeur de code

C'est une zone dans laquelle vous écrirez votre code et composerez / interpréterez de la musique. C'est un simple éditeur de texte où vous pourrez écrire votre code, l'effacer, couper et coller, etc. Pensez à lui comme à une version très basique de Word ou de Google Docs. L'éditeur coloriera automatiquement les mots selon leur signification dans le code. Ceci peut paraître étrange au début, mais vous le trouverez vite très utile. Par exemple, vous saurez que quelque chose est un nombre parce qu'elle sera bleue.

## E. Panneau des préférences

Sonic Pi supports a number of tweakable preferences which can be accessed by toggling the *prefs* button in the Info and Help button set. This will toggle the visibility of the Prefs Panel which includes a number of options to be changed. Examples are forcing mono mode, inverting stereo, toggling log output verbosity and also a volume slider and audio selector on the Raspberry Pi.

## F. Visualisateur de la trace

Quand vous exécutez votre code, l'information sur ce que le programme est en train de faire est affichée dans le visualiseur de la trace. Par défaut, vous verrez un message pour chaque son que vous créez avec l'heure exacte à laquelle le son a été déclenché. C'est très utile pour déboguer votre code et comprendre ce qu'il fait.

## G. Système d'aide

One of the most important parts of the Sonic Pi interface is the help system which appears at the bottom of the window. This can be toggled on and off by clicking on the blue *Help* button. The help system contains help and information about all aspects of Sonic Pi including this tutorial, a list of available synths, samples, examples, FX and a full list of all the functions Sonic Pi provides for coding music.

## H. Scope Viewer

The scope viewer allows you to see the sound you're hearing. You can easily see that the saw wave looks like a saw and that the basic beep is a curvey sine wave. You can also see the difference between loud and quiet sounds by the size of the lines. There are 3 scopes to play with - the default is a combined scope for the left and right channels, there is a stereo scope which draws a separate scope for each channel. Finally there is a Lissajous curve scope which will show the phase relationship between the left and right channels and allows you to draw pretty pictures with sound (https://en.wikipedia.org/wiki/Lissajous_curve).
