1.2 インターフェースの探索

# Sonic Pi のインターフェース

Sonic Piは、音楽をコーディング(記述)するための とてもシンプルなインターフェース(操作画面)を持っています。 ちょっと見てみましょう。

![Sonic Pi Interface](../images/tutorial/GUI.png)


*A* - 演奏の操作
*B* - 編集の操作
*C* - 情報とヘルプ
*D* - コードエディタ
*E* - 設定画面
*F* - ログビューア
*G* - ヘルプシステム
*H* - Scope Viewer

## A. 演奏の操作

ここにあるピンクのボタンで、音を再生したり停止するための主要な操作ができます。 *Run*ボタンは編集画面内のコードを実行します。*Stop*ボタンですべてのコードの動作を停止します。 *Save*ボタンは外部ファイルにコードを保存し、*Record*ボタンは演奏中の音を (WAV ファイルに)録音します。

## B. 編集の操作

これらのオレンジ色のボタンで編集画面を操作します。 *Size +*と*Size -*ボタンは文字サイズを大きくしたり小さくします。 *Align* ボタンはより見やすいコードに整えてくれます。

## C. 情報とヘルプ

これらの青いボタンで、情報、ヘルプや設定にアクセスします。*Info* ボタンは、 概要、コア、協力者、コミュニティ、ライセンス、ヒストリーといったSonic Pi自体についての情報を画面に表示します。 *Help*ボタンは*G*のヘルプシステム表示を切り替えます。 また*Prefs*ボタンは基本的なシステムを操作するための設定画面の表示を切り替えます。

## D. コードエディタ

ここでは音楽を作曲/演奏したりするためのコードを書く領域です。コードを書いたり、消したり、 切り取り、貼り付けなどを行うためのシンプルな編集画面です。Google Docsやワードの基本版だと思ってください。 編集画面ではコードの意味合いに応じて自動で色つけします。はじめは変わっていると思うかもしれませんが、 とても使いやすくなるはずです。例えば、数値は青色で示されます。

## E. 設定画面

Sonic Pi supports a number of tweakable preferences which can be accessed by toggling the *prefs* button in the Info and Help button set. This will toggle the visibility of the Prefs Panel which includes a number of options to be changed. Examples are forcing mono mode, inverting stereo, toggling log output verbosity and also a volume slider and audio selector on the Raspberry Pi.

## F. ログビューア

コードを走らせた時、ログ画面にはプログラムがどうなっているかについての情報が表示されます。 既定では、正確な再生時間を毎音ごとにメッセージとして見ることができます。 コードのデバッグ（欠陥を取り除く作業）に利用でき、コードが何をしているかを理解することにも役立ちます。

## G. ヘルプシステム

One of the most important parts of the Sonic Pi interface is the help system which appears at the bottom of the window. This can be toggled on and off by clicking on the blue *Help* button. The help system contains help and information about all aspects of Sonic Pi including this tutorial, a list of available synths, samples, examples, FX and a full list of all the functions Sonic Pi provides for coding music.

## H. Scope Viewer

The scope viewer allows you to see the sound you're hearing. You can easily see that the saw wave looks like a saw and that the basic beep is a curvey sine wave. You can also see the difference between loud and quiet sounds by the size of the lines. There are 3 scopes to play with - the default is a combined scope for the left and right channels, there is a stereo scope which draws a separate scope for each channel. Finally there is a Lissajous curve scope which will show the phase relationship between the left and right channels and allows you to draw pretty pictures with sound (https://en.wikipedia.org/wiki/Lissajous_curve).
