1.1 Live Coderen (Live Coding)

# Live Coderen

Een van de meest opwindende aspecten van Sonic Pi is, dat het je in staat stelt, code te gaan schrijven en *de code, ook live te wijzigen* om muziek te spelen, net zoals je live gitaar zou spelen. Dit betekent dat je, mits wat oefening, met Sonic Pi het podium op kan en hiermee kan optreden.

## Maak je hoofd leeg

Voor we in detail gaan over hoe Sonic Pi werkt, verderop in deze handleiding, wil ik je even de ervaring meegeven, hoe het voelt om live te coderen. Maak je geen zorgen als je hier niet veel (of niets) van begrijpt. Blijf gewoon even zitten en geniet ...

## Een loop "live" brengen

We gaan van start, kopieer de volgende code in een lege buffer hierboven:

```
live_loop :typmaarlustig do
  sample :bd_haus, rate: 1
  sleep 0.5
end
```

Klik nu op de `afspeel` knop en je zal een lekkere snelle basdrum horen vertrekken. Je kan nu, wanneer jij dat wenst, het geluid stoppen door op de `Stop`' knop te klikken. Maar doe dat nog even niet... neem in plaats daarvan de volgende stappen:

Zorg ervoor dat deze basdrum klank nog steeds loopt
Verander de waarde van 'sleep' van '0.5' naar een ietwat hoger getal,zoals bv. `1`.
Klik opnieuw op de `afspeelknop`
Merk op dat de snelheid van de drum hierbij veranderd is.
En, *onthou dit moment*, dit is de eerste keer dat je live hebt gecodeerd met Sonic Pi en het is waarschijnlijk niet je laatste keer...

Ok, dat was eenvoudig. We gaan er nog iets aan de mix toevoegen. Boven `sample :bd_haus` voeg je deze lijn toe  `sample :ambi_choir, rate: 0.3`. Jouw code moet er nu als volgt uitzien:

```
live_loop :typmaarlustig do
  sample :ambi_choir, rate: 0.3
  sample :bd_haus, rate: 1
  sleep 1
end
```

Now, play around. Change the rates - what happens when you use high values, or small values or negative values? See what happens when you change the `rate:` value for the `:ambi_choir` sample just slightly (say to `0.29`). What happens if you choose a really small `sleep` value? See if you can make it go so fast your computer will stop with an error because it can't keep up (if that happens, just choose a bigger `sleep` time and hit `Run` again).

Probeer één van de `sample` lijnen van een commentaar te voorzien door er een `#` voor te zetten:

```
live_loop :typmaarlustig do
  sample :ambi_choir, rate: 0.3
#  sample :bd_haus, rate: 1
  sleep 1
end
```

Merk op hoe het de computer opdraagt deze lijn te negeren, zodat we deze niet horen. Dit heet een comment (commentaarlijn). In Sonic Pi kunnen we een commentaarlijn gebruiken om klanken uit de mix te verwijderen of toe te voegen.

Ik laat je nu even met het volgende spelen. Neem de onderstaande code, en kopieer deze in een lege buffer. Probeer er nu nog niet al te veel van te begrijpen, maar wel in te zien dat er twee loops zijn - dus twee klanken die op het zelfde moment spelen. Het beste wat je kan doen nu is, experimenteren en er, gewoon op los, mee te gaan spelen. Hier zijn enkele suggesties:

Wijzig de blauwe `rate:` waarden en hoor hierbij dat de klank van de „sample” verandert.
Wijzig de `sleep` tijd en hoor dat beide loops kunnen afspelen met verschillende rusttijden.
Probeer de commentaarlijn te wissen (verwijder het `#`) uit onze voorbeeldlijn en geniet van de gitaarklank, die nu achteruit afspeelt.
Probeer de blauwe `mix:` waarden te veranderen naar cijfers tussen `0` (niet in de mix) en `1` (voluit in de mix).

Denk eraan te klikken op 'afspelen' om deze veranderingen te kunnen horen, bij de volgende loop die vertrekt. Maak je geen zorgen als het hierbij soms in de soep draait, klik dan op `Stop`, wis de code in de buffer en plak er een nieuwe kopie in, zo je bent weer gereed om opnieuw te gaan improviseren. Van je fouten kan je nu eenmaal het beste leren.


```
live_loop :guit do
  with_fx :echo, mix: 0.3, phase: 0.25 do
    sample :guit_em9, rate: 0.5
  end
#  sample :guit_em9, rate: -0.5
  sleep 8
end
live_loop :boom do
  with_fx :reverb, room: 1 do
    sample :bd_boom, amp: 10, rate: 1
  end
  sleep 8
end
```

Blijf nu spelen en experimenteren tot je de nieuwsgierigheid begint te voelen en je je begint af te vragen wat je hier nog allemaal mee kan doen. Dan ben je nu klaar om de rest van de handleiding te lezen.

Zo,waar wacht je nog op . . .
