1.2 De Interface Verkennen

# De Interface van Sonic Pi

Sonic Pi heeft een zeer eenvoudige interface om muziek te coderen. Laten we hier eens wat tijd aan besteden om deze te verkennen.

![Sonic Pi Interface](../images/tutorial/GUI.png)


*A* - Afspeel knoppen
*B* - Editor aanpassen
*C* - Info en Hulp
*D* - Code Editor
*E* - Paneel Voorkeursinstellingen
*F* - Log Venster
*G* - Hulp-Systeem
*H* - Scope Viewer

## A. Afspeel knoppen

Deze roze knoppen zijn de belangrijkste bedieningselementen voor het starten en stoppen van het geluid. Er is de *Afspelen* knop om de code in de editor af te spelen, *Stop* om alle actieve code te stoppen, *opslaan* om de code naar een extern bestand op te slaan en *Opnemen* om een opname (WAV-bestand) te maken van het afgespeelde geluid.

## B.  Controle over de Editor

Deze oranje knoppen kunt u gebruiken om de code editor te manipuleren. Met de *grootte +* en *grootte -* knoppen kan je de tekst groter en kleiner maken. De *uitlijnen* knop zal de code netjes worden gemaakt, zodat deze er professioneler gaat uitzien.

## C. Info and Hulp

Deze blauwe knoppen geven je toegang tot hulp-, informatie- en voorkeursinstellingen. De *Info* knop opent het venster die informatie over Sonic Pi zelf bevat - het kernteam, de geschiedenis, de medewerkers en ook de Sonic Pi "gemeenschap". De *Hulp* knop schakelt naar het hulp-systeem (*G*) en de *Voorkeuren* knop schakelt naar het voorkeur-venster waarmee u een aantal fundamentele systeemparameters kan bijsturen.

## D. Code Editor

Dit is het gebied waarin je jouw code schrijft en muziek componeert/uitvoert. Het is een eenvoudige tekst-editor, waarin je code kan schrijven, verwijderen, knippen en plakken, enz. Denk aan een zeer eenvoudige versie van Word of Google Docs. De editor zal de kleur van woorden automatisch aanpassen op basis van hun betekenis in de code. Dit lijkt misschien eerst wat vreemd, maar je zal dit snel heel nuttig vinden. Bijvoorbeeld als het het blauw ziet, dan weet je dat het om een getal gaat.

## E. Paneel Voorkeursinstellingen

Sonic Pi supports a number of tweakable preferences which can be accessed by toggling the *prefs* button in the Info and Help button set. This will toggle the visibility of the Prefs Panel which includes a number of options to be changed. Examples are forcing mono mode, inverting stereo, toggling log output verbosity and also a volume slider and audio selector on the Raspberry Pi.

## F. Log Venster

Wanneer je je code uitvoert,zal informatie over wat het programma doet, getoond worden in een soort logboek. Standaard zal je een berichtje zien, voor elk geluid dat je maakt, met de exacte tijd dat het geluid werd geactiveerd. Dit is zeer handig om fouten in je code op te kunnen sporen en om te kunnen begrijpen wat je code doet.

## G. Hulp Systeem

One of the most important parts of the Sonic Pi interface is the help system which appears at the bottom of the window. This can be toggled on and off by clicking on the blue *Help* button. The help system contains help and information about all aspects of Sonic Pi including this tutorial, a list of available synths, samples, examples, FX and a full list of all the functions Sonic Pi provides for coding music.

## H. Scope Viewer

The scope viewer allows you to see the sound you're hearing. You can easily see that the saw wave looks like a saw and that the basic beep is a curvey sine wave. You can also see the difference between loud and quiet sounds by the size of the lines. There are 3 scopes to play with - the default is a combined scope for the left and right channels, there is a stereo scope which draws a separate scope for each channel. Finally there is a Lissajous curve scope which will show the phase relationship between the left and right channels and allows you to draw pretty pictures with sound (https://en.wikipedia.org/wiki/Lissajous_curve).
