1.2 Zapoznanie z interfejsem użytkownika

# Interfejs użytkownika Sonic Pi

Sonic Pi ma bardzo prosty interfejs umożliwiający kodowanie muzyki. Poświęćmy chwilę na zapoznanie się z nim.

![Interfejs Sonic Pi](../images/tutorial/GUI.png)


*A* - Kontrola Odtwarzania
*B* - Kontrola Edytora
*C* - Informacje i Pomoc
*D* - Edytor Kodu
*E* - Panel Preferencji (Ustawienia)
*F* - Podgląd Logów
*G* - System Pomocy
*H* - Scope Viewer

## A. Kontrola Odtwarzania

Różowe przyciski zapewniają podstawową kontrolę nad uruchamianiem i zatrzymywaniem dźwięków. Jest przycisk *Run* (Uruchom), który umożliwia uruchomienie kodu znajdującego się w edytorze. Przycisk *Stop* (Zatrzymaj) umożliwia zatrzymanie aktualnie uruchomionego kodu. Przycisk *Save* (Zapisz) służy do zapisywania kodu wpisanego w edytorze do zewnętrznego pliku tekstowego. Przycisk *Record* (Nagrywaj) umożliwia nagranie aktualnie odtwarzanego dźwięku (w formacie WAV) .

## B. Kontrola Edytora

Pomarańczowe przyciski pozwalają Ci manipulować edytorem kodu. Przyciski *Size +* (Zwiększ rozmiar) i *Size -* (Zmniejsz rozmiar) umożliwiają powiększanie i zmniejszanie rozmiaru tekstu (czcionki). Przycisk *Align* (Wyrównaj) pozwala na uporządkowanie wyglądu Twojego kodu tak, aby wyglądał bardziej profesjonalnie (poprawia wcięcia).

## C. Informacje i Pomoc

Niebieskie przyciski dają Ci dostęp do informacji, pomocy i ustawień. Naciśnięcie przycisku *Info* (Informacje) spowoduje otworzenie dodatkowego okna, które zawiera informacje dotyczące Sonic Pi - podstawowa ekipa twórców programu, historia, współtwórcy oraz społeczność. Przycisk *Help* (Pomoc) otwiera i zamyka system pomocy (*G*), który właśnie czytasz. Przycisk *Prefs* (Ustawienia) otwiera i zamyka panel preferencji, który pozwala Ci na kontrolę kilku podstawowych ustawień aplikacji.

## D. Edytor Kodu

Jest to obszar, w którym będziesz pisał kod oraz komponował i wykonywał muzykę. Jest to prosty edytor tekstowy, w którym możesz pisać kod, kasować go, wycinać, wklejać, itd. Myśl o nim jako o bardzo prostej wersji edytora Word czy Google Docs. Edytor automatycznie koloruje słowa bazując na ich znaczeniu w kodzie. Na początku może się to wydawać dziwne, ale bardzo szybko zauważysz, że jest to bardzo przydatne. Na przykład - wiesz, że coś dany tekst jest liczbą, ponieważ ma kolor niebieski.

## E. Panel preferencji

Sonic Pi supports a number of tweakable preferences which can be accessed by toggling the *prefs* button in the Info and Help button set. This will toggle the visibility of the Prefs Panel which includes a number of options to be changed. Examples are forcing mono mode, inverting stereo, toggling log output verbosity and also a volume slider and audio selector on the Raspberry Pi.

## F. Podgląd Logów

Kiedy uruchamiasz swój kod, informacja o tym, co program aktualnie robi, będzie wyświetlana w panelu z logami. Domyślnie zobaczysz wiadomość pojawiającą się dla każdego dźwięku, który stworzysz, wraz z dokładnym czasem, kiedy ten dźwięk został uruchomiony. Jest to bardzo przydatne do debugowania Twojego kodu i zrozumienia, co on robi.

## G. System Pomocy

One of the most important parts of the Sonic Pi interface is the help system which appears at the bottom of the window. This can be toggled on and off by clicking on the blue *Help* button. The help system contains help and information about all aspects of Sonic Pi including this tutorial, a list of available synths, samples, examples, FX and a full list of all the functions Sonic Pi provides for coding music.

## H. Scope Viewer

The scope viewer allows you to see the sound you're hearing. You can easily see that the saw wave looks like a saw and that the basic beep is a curvey sine wave. You can also see the difference between loud and quiet sounds by the size of the lines. There are 3 scopes to play with - the default is a combined scope for the left and right channels, there is a stereo scope which draws a separate scope for each channel. Finally there is a Lissajous curve scope which will show the phase relationship between the left and right channels and allows you to draw pretty pictures with sound (https://en.wikipedia.org/wiki/Lissajous_curve).
