1.2 Exploring the Interface

# A Interface do Sonic Pi

O Sonic Pi tem um interface muito simples para programar música. Vamos passar algum tempo a explorá-la.

![Interface do Sonic Pi](../images/tutorial/GUI.png)


*A* - Controlos de Reprodução
*B* - Controlos do Editor
*C* - Informação e Ajuda
*D* - Editor (de código)
*E* - Painel de Opções
*F* - Vizualizador de logs
*G* - Sistema de Ajuda
*H* - Scope Viewer

## A. Controlos de Reprodução

Estes botões rosa são os controlos principais para reproduzir e parar sons. O botão *Run* serve para reproduzir o código no editor, *Stop* para parar todas as reproduções, *Save* para guardar o código num ficheiro externo e *Record* para gravar (num ficheiro WAV) o som que estiver a tocar.

## B. Controlos do Editor

Estes botões laranja permitem manipular o editor. Os botões *Size +* e *Size -* tornam o texto maior ou menor. O botão *Align* vai embelezar o código por ti para que pareça mais profissional.

## C. Informação e Ajuda

Estes botões azuis dão-te acesso a informação, ajuda e opções. O botão *Info* abre a janela de informação que contém informação sobre o Sonic Pi em si -- a equipa, histórico de actualizações (*changelog*), contribuidores e a comunidade. O botão *Help* abre e fecha o sistema de ajuda (*F*) e o botao *Prefs* abre e fecha a janela das opções que te permitem controlar alguns parâmetros básicos do sistema.

## D. Editor (de código)

Esta é a área on vais escrever o teu código e compôr/tocar música. É um editor de texto simples onde podes escrever código, apagá-lo, cortar e colar, etc. Pensa nele como uma versão básica do Word ou Google Docs. O editor muda a cor de palavras automaticamente baseado no seu significado no código. Isto pode parecer estranho de início, mas vais achá-lo muito útil no futuro. Por exemplo, saberás que algo é um número por ser azul.

## E. Painel de Opções

Sonic Pi supports a number of tweakable preferences which can be accessed by toggling the *prefs* button in the Info and Help button set. This will toggle the visibility of the Prefs Panel which includes a number of options to be changed. Examples are forcing mono mode, inverting stereo, toggling log output verbosity and also a volume slider and audio selector on the Raspberry Pi.

## F. Vizualizador de logs

Quando corres o teu código, vai ser mostrada informação sobre o que o programa está a fazer no Vizualizador do *log*. Por defeito, verás uma mensagem por cada som que crias com a hora exacta a que começou a tocar. Isto é útil para *debugging* e perceber o que o teu código está a fazer.

## G. Sistema de Ajuda

One of the most important parts of the Sonic Pi interface is the help system which appears at the bottom of the window. This can be toggled on and off by clicking on the blue *Help* button. The help system contains help and information about all aspects of Sonic Pi including this tutorial, a list of available synths, samples, examples, FX and a full list of all the functions Sonic Pi provides for coding music.

## H. Scope Viewer

The scope viewer allows you to see the sound you're hearing. You can easily see that the saw wave looks like a saw and that the basic beep is a curvey sine wave. You can also see the difference between loud and quiet sounds by the size of the lines. There are 3 scopes to play with - the default is a combined scope for the left and right channels, there is a stereo scope which draws a separate scope for each channel. Finally there is a Lissajous curve scope which will show the phase relationship between the left and right channels and allows you to draw pretty pictures with sound (https://en.wikipedia.org/wiki/Lissajous_curve).
