3.3 Stretching Samples

# Alongar Samples

Agora que sabemos como tocar uma variedade de synths e samples para criar música, está na hora de aprender a modificar tanto synths como samples para criar música ainda mais única e interessante. Primeiro, vamos explorar a habilidade de esticar e encolher samples.

## Representação de Samples

Samples são sons pré-gravados, quardados como números que representam como o cone da coluna se deve mover para criar som. O cone da coluna pode mover-se para dentro ou fora, e então, os números representam o quão dentro ou fora tem de estar o cone para cada momento no tempo. Uma sample normalmente tem de guardar vários milhares de números por segundo para para poder ser reproduzida com qualidade e precisão. O Sonic Pi pega nesses números e dá-os à velocidade certa para mover a coluna para dentro e fora e reproduzir o som. Mas também é divertido mudar a velocidade a que os números são alimentados às colunas para mudar o som.

## Mudar a Velocidade (Rate)

Vamos brincar com um dos sons de ambiente: `:ambi_choir`. Para tocá-la à velocidade (rate) normal, podes passar a opt `rate:` com o valor `1`:

```
sample :ambi_choir, rate: 1
```

Isto toca a sample à velocidade normal (1), nada de especial para já. Mas, podemos mudar esse valor para outro qualquer. Que tal `0.5`:

```
sample :ambi_choir, rate: 0.5
```

Wow! Que é que se passou aqui? Bem, duas coisas. Primeiro, a sample leva o dobro do tempo a tocar, segundo, o som está uma oitava abaixo. Vamos explorar estas coisas com um bocado mais de detalhe.

## Vamos alongar

Uma sample divertida de alongar e encolher é a "Amen Break". À velocidade normal, poderiamos pô-la numa música de *drum 'n' bass*:

```
sample :loop_amen
```

Mas ao mudar a rate podemos mudar o género de música. Experimenta metade da velocidade para um *hip-hop da velha-guarda*:

```
sample :loop_amen, rate: 0.5
```

Se aumentarmos a velocidade entramos no território *jungle*:

```
sample :loop_amen, rate: 1.5
```

Agora para o nosso truque final -- vamos ver o que acontece se usarmos uma rate negativa:

```
sample :loop_amen, rate: -1
```

Wow! Toca de trás para a frente! Agora experimenta muitas samples diferentes com rates diferentes. Experimenta rates muito altas e muito lentas. Vê que sons interessantes consegues produzir.

## Uma simples Explicação de Rates

Uma maneira de pensar em samples é como molas. Mudar a rate é como esticar ou encolher a mola. Se tocares a sample com `rate: 2`, estás a encolher a mola para metade do seu comprimento normal, e então a sample demora metade do tempo a tocar por ser mais curta. Se tocares a sample com `rate: 0.5`, estás a esticar a mola para o dobro do seu comprimento e, portanto, a sample demora o dobro do tempo a tocar por ser mais longa. Quanto a encolheres (rate mais alta), mais curta fica, quanto mais a esticares (rate mais baixa), mais longa fica.

Ao comprimir uma mola a sua densidade aumenta (número de voltas por cm) -- isto é parecido com a sample soar *mais aguda*. Ao esticar a mola a sua densidade diminui e é parecido com o som soar *mais grave*.


## A Matemática da Rate de Samples

(Esta parte é para aqueles interessados nos detalhes. Podes passar à frente se não for o teu caso...)

Como vimos acima, uma sample é representada por uma lista grade de números que representam onde a coluna deve estar ao longo do tempo. Podemos pegar nessa lista de números e usá-la para desenhar um gráfico que seria parecido com este:

![sample graph](../images/tutorial/sample.png)

Já deves ter visto imagens parecidas com esta antes. É chamada a *onda* de uma sample. É só uma gráfico de números. Normalmente, uma onda como esta terá 44100 pontos de informação por segundo (isto deve-se ao Teorema de Nyquist-Shannon). Então, se a sample durar 2 segundos, a onde vai ser representada por 88200 números, que vamos dar à coluna a uma velocidade de 44100 pontos por segundo. Claro, podíamos dá-los ao dobro da velocidade, que seria 88200 pontos por segundo. Levaria, portanto, apenas 1 segundo a tocar. Também podíamos tocá-la a metade da velocidade, que seria 22050 pontos por segundo, e levava 4 segundos a tocar.

A duração da sample é afectada pela velocidade (rate):

Dobro da rate diminui a duração para metade,
Metade da rate aumenta a duração para o dobro,
Rate de 1/4 multiplica a duração por quatro,
Com rate de 1/10 a sample dura 10 vezes mais.

Podemos representar isto com a seguinte fórmula:

```
new_sample_duration = (1 / rate) * sample_duration 
```

Mudar a rate também afecta a altura (não confundir com volume!) da sample. A frequência, ou altura, de uma onda é determinada por quão rápido se move para cima ou para baixo. O nosso cérebro, de alguma forma, transforma o movimento rápido das colunas em notas agudas e movimento lento em notas graves. É por isso que às vezes conseguimos ver as colunas a mexer.

Se pegares numa onda e a encolheres, ela vai-se mover para cima e para baixo mais vezes por segundo. Isto faz com que o som soe mais agudo. Acontece que duplicar o número de oscilações (movimentos para cima e para baixo) duplica a frequência. Então, *tocar uma sample ao dobro da rate duplica também a frequência a que a ouves*. E também, *diminuir a rate para metade vai diminuir a frequência para metade*. Outras rates vão afectar a frequência da mesma maneira.
