1.2 Обзор интерфейса

# Интерфейс Sonic Pi

У Sonic Pi очень простой интерфейс для кодирования музыки. Мы потратим совсем немного времени на его изучение.

![Интерфейс Sonic Pi](../images/tutorial/GUI.png)


*A* - Управление воспроизведением
*B* - Управление редактором
*C* - Помощь и справка
*D* - Редактор кода
*E* - Панель настроек
*F* - Просмотр сообщений
*G* - Справочная система
*H* - Scope Viewer

## A. Управление Воспроизведением

Эти розовые кнопки - главные элементы для начала и остановки звука. Есть кнопка *Выполнить* для запуска кода из редактора, *Остановить* для остановки всего выполняющегося кода, *Сохранить* для сохранения кода в файл и *Запись* для создания записи того, что вы слышите в звуковой файл в формате WAV.

## B. Управление Редактором

Оранжевые кнопки дают вам возможность манипулировать редактором кода. Кнопки *Размер +* и *Размер -* делают текст больше и меньше. Кнопка *Выровнять* автоматически выравнивает код, от чего он выглядит более профессионально.

## C. Помощь И Справка

Синие кнопки здесь дают вам доступ к информации и настройкам. Кнопка *Информация* открывает справочное окно, в котором находится информация о самом Sonic Pi - главной команде разработчиков, истории, помощниках и сообществе. Кнопка *Помощь* включает систему помощи (*F*), а кнопка *Параметры* включает панель настроек, где можно менять некоторые простые параметры приложения.

## D. Редактор Кода

Это область, в которой вы будете писать свой код и сочинять/исполнять музыку. Это простой текстовый редактор, где можно написать код, удалить его, вырезать, вставить и так далее. Представьте, что это простая версия Word или Google Docs. Редактор автоматически раскрасит слова в зависимости от их значения в коде. Поначалу это может казаться странным, но скоро вы увидите, насколько это помогает. К примеру, глядя на что-то синее ты будешь знать, что это число.

## E. Панель Настроек

Sonic Pi supports a number of tweakable preferences which can be accessed by toggling the *prefs* button in the Info and Help button set. This will toggle the visibility of the Prefs Panel which includes a number of options to be changed. Examples are forcing mono mode, inverting stereo, toggling log output verbosity and also a volume slider and audio selector on the Raspberry Pi.

## F. Просмотр Сообщений

Когда твой код выполняется, то информация о том, что делает программа, будет выводиться в просмотрщике сообщений. По умолчанию, ты будешь видеть новое сообщение для каждого воспроизводимого звука с точным указанием времени, когда он начался. Это очень полезно для отладки кода и понимание того, что он делает.

## G. Справочная Система

One of the most important parts of the Sonic Pi interface is the help system which appears at the bottom of the window. This can be toggled on and off by clicking on the blue *Help* button. The help system contains help and information about all aspects of Sonic Pi including this tutorial, a list of available synths, samples, examples, FX and a full list of all the functions Sonic Pi provides for coding music.

## H. Scope Viewer

The scope viewer allows you to see the sound you're hearing. You can easily see that the saw wave looks like a saw and that the basic beep is a curvey sine wave. You can also see the difference between loud and quiet sounds by the size of the lines. There are 3 scopes to play with - the default is a combined scope for the left and right channels, there is a stereo scope which draws a separate scope for each channel. Finally there is a Lissajous curve scope which will show the phase relationship between the left and right channels and allows you to draw pretty pictures with sound (https://en.wikipedia.org/wiki/Lissajous_curve).
